#version 120


uniform int worldTime;

varying vec4 color;
varying vec4 texcoord;
varying vec4 lmcoord;

varying vec3 normal;

attribute vec4 mc_Entity;

varying float iswater;

uniform float frameTimeCounter;
uniform vec3 cameraPosition;
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

const float PI = 3.1415927;


void main() {

	iswater = 0.0f;

	vec4 position = gl_ModelViewMatrix * gl_Vertex;

	/* un-rotate */
	vec4 viewpos = gbufferModelViewInverse * position;

	vec3 worldpos = viewpos.xyz + cameraPosition;
	float displacement = 0.0;

	
if(mc_Entity.x == 8.0 || mc_Entity.x == 9.0) { 
	iswater = 1.0;
	    float fy = fract(worldpos.y + 0.001);
	    if (fy > 0.002)
		{
		    /* animate */
			float wave = 0.05 * sin(2 * PI * (frameTimeCounter*0.75 + worldpos.x /  7.0 + worldpos.z / 13.0))
		               + 0.05 * sin(2 * PI * (frameTimeCounter*0.6 + worldpos.x / 11.0 + worldpos.z /  5.0));
					   displacement = clamp(wave, -fy, 1.0-fy);
			viewpos.y += displacement;
		}
	}

	/* re-rotate */
	viewpos = gbufferModelView * viewpos;

	/* projectify */
	gl_Position = gl_ProjectionMatrix * viewpos;
	
	
	color = gl_Color;
	
	texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;

	lmcoord = gl_TextureMatrix[1] * gl_MultiTexCoord1;
	
	gl_FogFragCoord = gl_Position.z;
	
	
	normal = normalize(gl_NormalMatrix * normalize(gl_Normal) + vec3(0.33*-displacement,0.0,0.16*displacement));

	
}